IF NOT EXISTS (select * from sys.objects where  OBJECT_ID =  OBJECT_ID(N'AMS_ItemRole_Back'))
BEGIN
PRINT 'Started - Data back from AMS_ItemRole to AMS_ItemRole_Back for any references'
 
 SELECT * INTO AMS_ItemRole_Back FROM AMS_ItemRole

 PRINT 'Completed - Data back from AMS_ItemRole to AMS_ItemRole_Back for any references'
 END
GO

PRINT 'Deleting the duplicate records from AMS_ItemRole table';

WITH cteItemRoleRecords (ItemRoleID,ItemID,ContractID, RoleID,row_number)
AS
(
SELECT ItemRoleID,ItemID,ContractID, RoleID, ROW_NUMBER() OVER (Partition by ItemID,ContractID, RoleID ORDER BY ItemID,ContractID, RoleID) row_number from AMS_ItemRole itemrole 
WHERE RoleID is not null
GROUP BY ItemRoleID,ItemID,ContractID, RoleID
)
DELETE FROM AMS_ItemRole WHERE ItemRoleID not in (SELECT ItemRoleID FROM cteItemRoleRecords cterole
WHERE row_number = (SELECT MAX(row_number) FROM cteItemRoleRecords WHERE cterole.ItemID=ItemID and cterole.ContractID=ContractID
and cterole.RoleID=RoleID GROUP BY ItemID,ContractID, RoleID))
and RoleID is not null;

WITH cteItemPersonRecords (ItemRoleID,ItemID,ContractID, PersonID_,row_number)
AS
(
SELECT ItemRoleID,ItemID,ContractID, PersonID_, ROW_NUMBER() OVER (Partition by ItemID,ContractID, PersonID_ ORDER BY ItemID,ContractID, PersonID_) row_number from AMS_ItemRole itemrole 
WHERE PersonID_ is not null
GROUP BY ItemRoleID,ItemID,ContractID, PersonID_
)
DELETE FROM AMS_ItemRole WHERE ItemRoleID not in (SELECT ItemRoleID FROM cteItemPersonRecords cterole
WHERE row_number = (SELECT MAX(row_number) FROM cteItemPersonRecords WHERE cterole.ItemID=ItemID and cterole.ContractID=ContractID
and cterole.PersonID_=PersonID_ GROUP BY ItemID,ContractID, PersonID_))
and PersonID_ is not null

PRINT 'Completed deleting the duplicate records from AMS_ItemRole'
