IF NOT EXISTS (select * from sys.objects where  OBJECT_ID =  OBJECT_ID(N'AMS_TemplateRole_BACK'))
BEGIN
PRINT 'Copying the AMS_TemplateRole table data to AMS_TemplateRole_Back table'
PRINT 'Started - Data back from AMS_TemplateRole to AMS_TemplateRole_BACK for any references'
 
 SELECT * INTO AMS_TemplateRole_BACK FROM AMS_TemplateRole
 PRINT 'Completed - Data back from AMS_TemplateRole to AMS_TemplateRole_BACK for any references' 

PRINT 'Pushing the data from the AMS_ItemRole table data to AMS_templateRole table if not exists'

DECLARE @ItemRoleCursor CURSOR;
DECLARE @ItemRoleContractID uniqueidentifier;
DECLARE @TemplateRoleTemplateID uniqueidentifier;
BEGIN
    SET @ItemRoleCursor = CURSOR FOR
	SELECT distinct itemrole.ContractID,cont.TemplateID from AMS_ItemRole itemrole 
	inner join AMS_Contracts cont on cont.ContractID=itemrole.ContractID
	
    OPEN @ItemRoleCursor 
    FETCH NEXT FROM @ItemRoleCursor 
    INTO @ItemRoleContractID,@TemplateRoleTemplateID
    WHILE @@FETCH_STATUS = 0
    BEGIN	
			Declare @TemplateRoleCursor Cursor
			Declare @ItemID uniqueidentifier,@RoleID uniqueidentifier,@Permission nchar,@EventType int,@ExternalEmailId uniqueidentifier,@PersonID_ uniqueidentifier
				
				BEGIN
				PRINT 'Fetching all the records from AMS_ItemRole for ContractID - ' + convert(varchar(50), @ItemRoleContractID)
				 SET @TemplateRoleCursor = CURSOR FOR 
				 SELECT ItemID,RoleID,Permission,EventType,ExternalEmailId,PersonID_ from AMS_ItemRole where ContractID=@ItemRoleContractID

				  OPEN @TemplateRoleCursor 
					FETCH NEXT FROM @TemplateRoleCursor 
					INTO @ItemID ,@RoleID ,@Permission ,@EventType ,@ExternalEmailId ,@PersonID_
					WHILE @@FETCH_STATUS = 0
					BEGIN
					IF (@RoleID is not null AND @PersonID_ is null)
						BEGIN
							IF NOT EXISTS (select * from AMS_TemplateRole temprole where temprole.ItemID=@ItemID AND temprole.RoleID=@RoleID  AND 
							temprole.TemplateID=@TemplateRoleTemplateID)
								BEGIN
									INSERT INTO AMS_TemplateRole(TemplateRoleID,ItemID,RoleID,Permission,EventType,ExternalEmailId,PersonID_,TemplateID) Values(Newid(), @ItemID,@RoleID,@Permission,@EventType,@ExternalEmailId,@PersonID_,@TemplateRoleTemplateID)
								END
						END
					ELSE
						BEGIN
							IF NOT EXISTS (select * from AMS_TemplateRole temprole where temprole.ItemID=@ItemID AND temprole.PersonID_=@PersonID_  AND 
							temprole.TemplateID=@TemplateRoleTemplateID)
								BEGIN
									INSERT INTO AMS_TemplateRole(TemplateRoleID,ItemID,RoleID,Permission,EventType,ExternalEmailId,PersonID_,TemplateID) Values(Newid(), @ItemID,@RoleID,@Permission,@EventType,@ExternalEmailId,@PersonID_,@TemplateRoleTemplateID)
								END
						END;
					
					 FETCH NEXT FROM @TemplateRoleCursor 
					 INTO @ItemID ,@RoleID ,@Permission ,@EventType ,@ExternalEmailId ,@PersonID_ 
					END; 
				  CLOSE @TemplateRoleCursor ;
				  DEALLOCATE @TemplateRoleCursor;
				END;
      FETCH NEXT FROM @ItemRoleCursor 
      INTO @ItemRoleContractID,@TemplateRoleTemplateID 
    END; 
    CLOSE @ItemRoleCursor ;
    DEALLOCATE @ItemRoleCursor;
END;

PRINT 'Updating the MajorMinorType and DataWFType values'
--Update WFMajorItemid
Update ir set ir.MajorMinorType =1,ir.DataWFType=2 from AMS_TemplateRole ir inner join AMS_WFMajorItemTpl mj on mj.WFMajorItemID = ir.ItemID  
-- Update WFMinorItemId
Update ir set ir.MajorMinorType =2,ir.DataWFType=2 from AMS_TemplateRole ir inner join AMS_WFMinorItemTpl mi on mi.WFMinorItemID = ir.ItemID
--Update DataMajorItem
Update ir set ir.MajorMinorType =1,ir.DataWFType=1 from AMS_TemplateRole ir inner join AMS_DataMajorItemTpl dmj on dmj.DataMajorItemID= ir.ItemID
--Update DataminiorItem
 Update ir set ir.MajorMinorType =2,ir.DataWFType=1 from AMS_TemplateRole ir inner join AMS_DataMinorItemTpl dmn on dmn.DataMinorItemID= ir.ItemID	  

PRINT 'Reset the Permissions back to AMS_ItemRole table from AMS_TemplateRole'

DECLARE @TemplateCursor CURSOR;
DECLARE @TemplateIDField uniqueidentifier;
BEGIN
    SET @TemplateCursor = CURSOR FOR
	select distinct temprole.TemplateId from AMS_TemplateRole temprole inner join AMS_Templates temp
	ON temp.TemplateID=temprole.TemplateID and temp.OriginalTemplateID is null 
    OPEN @TemplateCursor 
    FETCH NEXT FROM @TemplateCursor 
    INTO @TemplateIDField
    WHILE @@FETCH_STATUS = 0
    BEGIN
	PRINT 'Fetching all the records from AMS_TemplateRole for TemplateID - ' + convert(varchar(50), @TemplateIDField)
			DECLARE @ContractCursor CURSOR;
			DECLARE @ContractIDField uniqueidentifier;
			BEGIN
				SET @ContractCursor = CURSOR FOR
				SELECT distinct itemrole.ContractID from AMS_ItemRole itemrole 
				inner join AMS_Contracts cont on cont.ContractID=itemrole.ContractID and cont.TemplateID=@TemplateIDField				

				OPEN @ContractCursor 
				FETCH NEXT FROM @ContractCursor 
				INTO @ContractIDField
				WHILE @@FETCH_STATUS = 0
				BEGIN				
				
				Delete from AMS_ItemRole where ContractID=@ContractIDField
				PRINT 'Deleting all the records from AMS_ItemRole for ContractID - ' + convert(varchar(50), @ContractIDField)				
						
				Insert into AMS_ItemRole(ItemID,ContractID,MajorMinorType,DataWFType,RoleID,Permission,EventType,ExternalEmailId,PersonID_) 
				select ItemID,@ContractIDField,MajorMinorType,DataWFType,RoleID,Permission,EventType,ExternalEmailId,PersonID_ 
				from AMS_TemplateRole where TemplateID=@TemplateIDField
				PRINT 'Inserting all the records to AMS_ItemRole for ContractID - ' + convert(varchar(50), @ContractIDField)	

				  FETCH NEXT FROM @ContractCursor 
				  INTO @ContractIDField 
				END;
				CLOSE @ContractCursor ;
				DEALLOCATE @ContractCursor;
			END;	 
      FETCH NEXT FROM @TemplateCursor 
      INTO @TemplateIDField 
    END; 
    CLOSE @TemplateCursor ;
    DEALLOCATE @TemplateCursor;
END;

PRINT 'Completed all the operations Succesfully!'

 END
 ELSE
 PRINT 'Scripts are already executed, if you want to re-run the scripts again, please execute the rollback/revert scripts and execute it once again'
GO